import es
import playerlib
import gamethread
import effectlib
import vecmath

hook_color = 1
hook_speed = 0.25
hook_width = 25
hook_stepsize = 100
hook_delay = 0.1
hook = {}

def load():
	es.set("eventscripts_cmdprefixes","!+-")
	es.regclientcmd("+hook","null","null")
	es.regclientcmd("-hook","null","null")

def es_client_command(ev):
	if str(ev['command']).lower() == "+hook":
		hooks(int(ev['userid']))
	if str(ev['command']).lower() == "-hook":
		unhook(int(ev['userid']))

def unload():
	es.set("eventscripts_cmdprefixes","!")
	es.unregclientcmd("+hook")
	es.unregclientcmd("-hook")

def player_death(ev):
	userid = int(ev['userid'])
	hook[userid] = 0

def player_discsonnect(ev):
	userid = int(ev['userid'])
	del hook[userid]

def unhook(userid):
	hook[userid] = 0

def hooks(userid):
	myPlayer = playerlib.getPlayer(userid)
	if myPlayer.get("isdead"):
		return
	hook[userid] = 1
	target_location = vecmath.Vector(myPlayer.get('viewcoord'))
	hook_action(userid,target_location)

def hook_action(userid,loc2):
	loc1 = vecmath.Vector(es.getplayerlocation(userid))
	if not userid in hook:
		hook[userid] = 0
	if hook[userid] == 0:
		return
	team = es.getplayerteam(userid)
	red = green = blue = 255
	if hook_color > 0:
		if team == 2:
			green = 0
			blue = 0
		elif team == 3:
			red = 0
			green = 0
	effectlib.drawLine(loc1,loc2,"sprites/lgtning.vmt","sprites/lgtning.vmt",0.2,hook_width,hook_width,red,green,blue,150,30,0,0,0,0)
	loc3 = (loc2 - loc1)*hook_speed
	if loc3.z > 0:
		loc3.z *= 2
	else:
		loc3.z *= 0.5
	if loc3.x > 2000:
		loc3.x = 2000
	if loc3.y > 2000:
		loc3.y = 2000
	if loc3.z > 2000:
		loc3.z = 2000
	if loc3.x < -2000:
		loc3.x = -2000
	if loc3.y < -2000:
		loc3.y = -2000
	if loc3.z < -2000:
		loc3.z = -2000
	es.setplayerprop(userid,"CBasePlayer.localdata.m_vecBaseVelocity", str(loc3))
	gamethread.delayed(hook_delay,hook_action,(userid,loc2))